GEGELATI

Loading...
Searching...
No Matches
Public Member Functions | Protected Attributes | List of all members
TPG::TPGExecutionEngine Class Reference

`#include <tpgExecutionEngine.h>`

Inheritance diagram for TPG::TPGExecutionEngine:

## Public Member Functions
| TPGExecutionEngine (const Environment &env, Archive *arch=NULL)
| Main constructor of the class.
virtual | ~TPGExecutionEngine ()=default
| Default virtual destructor.
void | setArchive (Archive *newArchive)
| Set a new Archive for storing Program results.
void | applyActivationFunctionOnActions (std::vector< double > &actionsTaken)
| Apply a sigmoid function on all the actions.
virtual double | evaluateEdge (const TPGEdge &edge)
| Execute the Program associated to an Edge and returns the obtained double.
virtual const TPG::TPGEdge & | evaluateTeam (const TPGTeam &team)
| Evaluate all the Program of the outgoing TPGEdge of the TPGTeam.
virtual const std::pair< std::vector< const TPG::TPGVertex * >, std::vector< double > > | executeFromRoot (const TPGVertex &root, const std::vector< uint64_t > &initActions={0})
| Execute the TPGGraph starting from the given TPGVertex.

## Protected Attributes
Archive * | archive
| Archive for recording Program results.
const Environment & | env
| Environment used.
Program::ProgramExecutionEngine | progExecutionEngine
| ProgramExecutionEngine for executing Programs of edges.

## Detailed Description

Class in charge of executing a TPGGraph.

This first implementation is purely sequential and does not parallelize Program execution, nor executions of the TPG starting from several roots.

## Constructor & Destructor Documentation

## ◆ TPGExecutionEngine()

TPG::TPGExecutionEngine::TPGExecutionEngine | ( | const Environment & | env,
|  | Archive * | arch = NULL )
| inline

Main constructor of the class.

Parameters

  [in] | env | Environment in which the Program of the TPGGraph will be executed.
  [in] | arch | pointer to the Archive for storing recordings of the Program Execution. By default, a NULL pointer is given, meaning that no recording of the execution will be made.

## Member Function Documentation

## ◆ applyActivationFunctionOnActions()

void TPG::TPGExecutionEngine::applyActivationFunctionOnActions | ( | std::vector< double > & | actionsTaken | ) |

Apply a sigmoid function on all the actions.

Parameters

  [in] | actionsTaken | a reference to the action taken

## ◆ evaluateEdge()

double TPG::TPGExecutionEngine::evaluateEdge | ( | const TPGEdge & | edge | ) |
| virtual

Execute the Program associated to an Edge and returns the obtained double.

If an Archive is associated to the TPGExecutionEngine, the Program result is recorded in it.

If the value returned by the Program is NaN, then it is replaced with a -inf value.

Parameters

  [in] | edge | the const ref to the TPGEdge whose Program will be evaluated.

Returns
  the double value returned by the Program of the TPGEdge.

Reimplemented in TPG::TPGExecutionEngineInstrumented.

## ◆ evaluateTeam()

const TPG::TPGEdge & TPG::TPGExecutionEngine::evaluateTeam | ( | const TPGTeam & | team | ) |
| virtual

Evaluate all the Program of the outgoing TPGEdge of the TPGTeam.

This method evaluates the Programs of all outgoing TPGEdge of the TPGTeam, and returns the reference to the TPGEdge providing the largest evaluation.

Parameters

  [in] | team | the TPGTeam whose outgoing TPGEdge are evaluated.

Returns
  the reference to the TPGEdge evaluated with the the highest double value (and not excluded).

Exceptions

  std::runtime_error | in case the TPGTeam has no outgoing edge. This should not happen in a correctly constructed TPGGraph.

Reimplemented in TPG::TPGExecutionEngineInstrumented.

## ◆ executeFromRoot()

const std::pair< std::vector< const TPG::TPGVertex * >, std::vector< double > > TPG::TPGExecutionEngine::executeFromRoot | ( | const TPGVertex & | root,
|  | const std::vector< uint64_t > & | initActions = {0} )
| virtual

Execute the TPGGraph starting from the given TPGVertex.

This method browse the graph by successively evaluating Teams and following the TPGEdge proposing the best bids.

Parameters

  [in] | root | the TPGVertex from which the execution will start.
  [in] | initActions | the vector of initial action that can be chosen by default by the root.

Returns
  a vector containing all the TPGVertex traversed during the evaluation of the TPGGraph. The TPGAction resulting from the TPGGraph execution is at the end of the returned vector.

Reimplemented in TPG::TPGExecutionEngineInstrumented.

## ◆ setArchive()

void TPG::TPGExecutionEngine::setArchive | ( | Archive * | newArchive | ) |

Set a new Archive for storing Program results.

Parameters

  [in] | newArchive | A pointer (possibly NULL) to an Archive.

Copyright or © or Copr. IETR/INSA - Rennes (2019 - 2025) :

Karol Desnos kdesn.nosp@m.os@i.nosp@m.nsa-r.nosp@m.enne.nosp@m.s.fr (2019 - 2022) Quentin Vacher qvach.nosp@m.er@i.nosp@m.nsa-r.nosp@m.enne.nosp@m.s.fr (2025) Thomas Bourgoin tbour.nosp@m.goi@.nosp@m.insa-.nosp@m.renn.nosp@m.es.fr (2021)

GEGELATI is an open-source reinforcement learning framework for training artificial intelligence based on Tangled Program Graphs (TPGs).

This software is governed by the CeCILL-C license under French law and abiding by the rules of distribution of free software. You can use, modify and/ or redistribute the software under the terms of the CeCILL-C license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".

As a counterpart to the access to the source code and rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty and the software's author, the holder of the economic rights, and the successive licensors have only limited liability.

In this respect, the user's attention is drawn to the risks associated with loading, using, modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean that it is complicated to manipulate, and that also therefore means that it is reserved for developers and experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or data to be ensured and, more generally, to use and operate it in the same conditions as regards security.

The fact that you are presently reading this means that you have had knowledge of the CeCILL-C license and that you accept its terms.

## Member Data Documentation

## ◆ progExecutionEngine

Program::ProgramExecutionEngine TPG::TPGExecutionEngine::progExecutionEngine
| protected

ProgramExecutionEngine for executing Programs of edges.

Keeping this ProgramExecutionEngine as an attribute avoids wasting time rebuilding a new one for each edge.

The documentation for this class was generated from the following files:

- D:/a/gegelati/gegelati/gegelatilib/include/tpg/tpgExecutionEngine.h
- D:/a/gegelati/gegelati/gegelatilib/src/tpg/tpgExecutionEngine.cpp